<?php

//
// Ce fichier ne sera execute qu'une fois
if (defined("_INC_CALCUL_SQUEL")) return;
define("_INC_CALCUL_SQUEL", "1");

include("inc-parse-squel.php3");
include("inc-gen-squel.php3");
include("inc-champ-squel.php3");

function calculer_squelette($squelette, $fichier) {
	global $trace;
	global $racine;
	global $boucles;
	$x=microtime();
	$boucles = '';
	$racine = '';
	$trace = fopen("/tmp/trace", "a");
	parser(join(file("$squelette.html"), ""));

	$squelette_nom = ereg_replace("[^a-zA-Z0-9_]", "_", $squelette);
	$func = 'squelette_'.$squelette_nom.'_executer';
	$prefix = $func.'_boucle';

	// Calculer le code PHP des boucles
	if ($boucles) {
		reset($boucles);
		while (list($id_boucle, ) = each($boucles)) {
		  $codes[] = calculer_boucle($id_boucle, $prefix);
		}
	}

	// Calculer le code PHP de la racine

	$r = calculer_liste($racine, $prefix, '');
	if (!(ereg("[[:space:]]*\\\$ret \.=(.*)$", $r,$m)))
	  $r = "\n\t\$ret = '';$r\n\treturn \$ret;\n}";
	else { if (strpos($m[1],'$ret'))
	  $r = "\n\t\$ret =$m[1]\n\treturn \$ret;\n}";
	else $r = "\n\treturn $m[1]\n}"; }
	$codes[] = "function $func(\$contexte) {
 global \$pile_boucles;
 \$pile_boucles = Array();" .
	  $r;
	$f = fopen($fichier, "wb");
	$define = strtoupper("_SKEL_$squelette_nom");
	fwrite($f, 
	       "<?php\n
\$func_squelette_executer = '$func';
if (defined(\"$define\")) return;
define(\"$define\", \"1\");\n\n");
	foreach ($codes as $texte) {fwrite($f, $texte);fwrite($f,"\n");}
#	list($usecy, $secy) = explode(" ",microtime());
#	list($usecx, $secx) = explode(" ",$x);
#	fwrite($f, "# compil en moins de ");
#	fwrite($f, (($secy + $usecy)- ($secx + $usecx)));
#	fwrite($f, " secondes sur un G3/500\n");
	fwrite($f, "?>\n");
	fclose($f);
#	$f=fopen("/tmp/c.php3","wb"); // pour debugger
#	foreach ($codes as $texte) {fwrite($f, $texte);fwrite($f,"\n\n");}
#	fclose($trace);
}
?>
